#/usr/bin/perl
use Unicode::String qw(utf8);
<<DOC;
 Le programme prend en entre le nom du rpertoire contenant les fils RSS  traiter.
 Le programme construit en sortie 3 rpertoires: methode-1-xml, methode-1-txt, methode-1-treetagger.
 Les fichiers du rpertoire methode-1-xml contiennent pour chaque fil RSS trait:
 le nom du fichier trait,
 la date de cration de ce fichier,
 les titres et les descriptions des articles rsums.
 Les fichiers du rpertoire methode-1-txt contiennent pour chaque fil RSS trait:
 les titres et les descriptions des articles rsums.
 Les fichiers du rpertoire methode-1-treetagger contiennent pour chaque fil RSS trait:
 les titres et les descriptions des articles rsums tiquets par treetagger.
DOC
#-----------------------------------------------------------
my $rep="$ARGV[0]";
# on s'assure que le nom du rpertoire ne se termine pas par un "/"
$rep=~ s/[\/]$//;
#----------------------
# sorties :
$dir1="methode-1-xml";
$dir2="methode-1-txt";
$dir3="methode-1-treetagger";
mkdir($dir1) || print $!;
mkdir($dir2) || print $!;
mkdir($dir3) || print $!;
#----------------------
my $output1;
my $output2;
my $output3;
#----------------------
my %dictionnairedesitems=();
#----------------------------------------
&parcoursarborescencefichiers($rep);	#recurse!
#----------------------------------------
#Impression du </contenu> final
opendir(DIRxml, $dir1) or die "can't open $dir1: $!\n";
my @xml = readdir(DIRxml);
closedir(DIRxml);
foreach my $xml (@xml){
    my $fic=$dir1."/".$xml;
    open (XML,">>:encoding(UTF-8)", "$fic");
    print XML "</contenu>";
    close (XML);
}
#-------------------------------------------
#Impression du </contenu> final
opendir(DIRtreet, $dir3) or die "can't open $dir1: $!\n";
my @xml = readdir(DIRtreet);
closedir(DIRtreet);
foreach my $xml (@xml){
    my $fic=$dir3."/".$xml;
    open (XML,">>:encoding(UTF-8)", "$fic");
    print XML "</contenu>";
    close (XML);
}
exit;
#----------------------------------------------
sub parcoursarborescencefichiers {
    my $path = shift(@_);
    print $path,"\n";
    opendir(DIR, $path) or die "can't open $path: $!\n";
    my @files = readdir(DIR);
    closedir(DIR);
    foreach my $file (@files) {
	next if $file =~ /^\.\.?$/;
	my $filetmp=$file;
	$file = $path."/".$file;
	if (-d $file) {
	    &parcoursarborescencefichiers($file);	#recurse!
	}
	if (-f $file) {
	
	if (-s $file){
	
	    if (($file=~/\.xml$/) && ($filetmp!~/^fil/)){		
		print "$file: ", $i++,"\n";
		#Lecture du fichier pour reperer l'encodage
		open(FILE, $file);
		my $line=<FILE>;
		close(FILE);
		$line=~ s/> *</></g;
		$line=~/encoding=[\"\']([^\"\']+)[\"\']/;
		my $encoding=$1;
		print "Encodage: $encoding\n";
		# lecture du fichier pour lire les donnees avec le bon encodage				
		open(FILE,"<:encoding($encoding)", $file);
		$line="";
		while (my $ligne=<FILE>){
		    chomp ($ligne);
		    $line.=$ligne;
		}
		close(FILE);
		$line=~ s/> *</></g;
		&itemtitle($line, $encoding, $filetmp);
		
	    }
	 }   
	}
    } 
}
#-----------------------------------------------
sub itemtitle {
    my $line = shift(@_);
    my $encoding= shift(@_);
	my $filetmp= shift(@_);
    if ($line =~/<item><title>/i){			
	my $rubrique;
	if ($line=~/<channel><title>([^<]+)<\/title>/i) {$rubrique=$1;}
	#--- Ajout SF ----
	$rubrique=~ tr//AAAAAACEEEEIIIINOOOOOUUUUYaaaaaaceeeeiiiinooooouuuuyy/;
	$rubrique=~ s/ //g;
	$rubrique=uc($rubrique);
	if ($rubrique eq "") {
	    $rubrique="RUBRIQUE_NON_RECONNUE";
		}
	$rubrique=~s/LEMONDE.FR//;
	$rubrique=~s/SPORTS/SPORT/;
	$rubrique=~s/VOYAGES/VOYAGE/;
	$rubrique=~s/[[:punct:]]//g;
	
	#-----------------
	if (uc($encoding) ne "UTF-8") {utf8($rubrique);}
	
	if ($line=~/<pubDate>([^<]+)<\/pubDate>/i){$date=$1;}
	
	my $contin=0;
	while ($line=~/<item><title>([^<]+)<\/title><link>[^<]+<\/link><description>([^<]+)<\/description>/g) {
	    my $title=$1;
	    my $description=$2;
	    if (uc($encoding) ne "UTF-8") {utf8($date); utf8($title); utf8($description);}
	    $date=&nettoietexte($date);
	    #my $date3="Date: ".$date."\n";
	    #$date="<date>".$date."</date>\n";			
	    $title=&nettoietexte($title);
	    $description=&nettoietexte($description);
	    print "avant ",$contin,"\n";
	    if (!(exists($dictionnairedesitems{$description}))){
		$dictionnairedesitems{$description}++;
		my ($titreetiq,$resumeetiq)=&etiquetageavectreetagger($title, $description);
		$output1=$dir1."/".$rubrique."-SORTIE.xml";
		$output2=$dir2."/".$rubrique."-SORTIE.txt";
		$output3=$dir3."/".$rubrique."-SORTIE-treet.xml";
		open(FILEOUT, $output1);
		my $stroka;
		while ($stroka=<FILEOUT> && $contin==0){ 			
		    if ($stroka= ~/version="1.0"/) {
			$contin=1;
		    }
		}
		close(FILEOUT);
		print "aprs ",$contin,"\n";
		#Impression
		if (!open (FILEOUT,">>:encoding(UTF-8)", "$output1")) { die "Pb a l'ouverture du fichier $output1"};
		if (!open (FILEOUT2,">>:encoding(UTF-8)", "$output2")) { die "Pb a l'ouverture du fichier $output2"};
		if (!open (FILEOUT3,">>:encoding(UTF-8)", "$output3")) { die "Pb a l'ouverture du fichier $output3"};
		
		if ($contin==0){
		    print FILEOUT "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<contenu>\n<file>$filetmp</file>\n<date>$date</date>\n<title>$title</title>\n<description>$description</description>\n";
		}
		else {
		    print FILEOUT "\n<file>$filetmp</file>\n<date>$date</date>\n<title>$title</title>\n<description>$description</description>\n";
		}
		
		if ($contin==0) {
		    print FILEOUT3 "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<contenu>\n\n\n<title>\n\n$titreetiq</title>\n\n\n<description>\n\n$resumeetiq</description>\n\n\n\n";
		}
		else {
		    print FILEOUT3 "\n<title>\n\n$titreetiq</title>\n\n\n<description>\n\n$resumeetiq</description>\n\n\n\n";
		}
		
		print FILEOUT2 "$title\n\n$description\n\n\n";
		close(FILEOUT);
		close(FILEOUT2);
		close(FILEOUT3);
		
	    }
	}
    }  
}	
#----------------------------------------------
#----------------------------------------------------
sub nettoietexte {
    my $texte=shift;
    $texte =~ s/&lt;/</g;
    $texte =~ s/&gt;/>/g;
    $texte =~ s/<a href[^>]+>//g;
    $texte =~ s/<img[^>]+>//g;
    $texte =~ s/<\/a>//g;
	$texte =~ s/&#38;/&/g;
	$texte =~ s/&#34;/"/g;
	$texte =~ s/&#39;/'/g;
	$texte =~ s/<[^>]+>//g;
    return $texte;
}
#----------------------------------------------------
sub etiquetageavectreetagger {
    my ($titre,$texte)=@_;
    #----- le titre
    my $tmptag="texteaetiqueter.txt";
    open (TMPFILE,">:encoding(utf-8)", $tmptag);
    print TMPFILE $titre,"\n";
    close(TMPFILE);
    system("perl cmd/tokenise-fr.pl $tmptag | tree-tagger langues-treetagger/french-utf8.par -lemma -token -no-unknown -sgml > treetagger.txt");
    system("perl cmd/treetagger2xml-nadia.pl treetagger.txt");
    # lecture du resultat tagge en xml :
    open(OUT,"<:encoding(utf-8)","treetagger.txt.xml");
    my $fistline=<OUT>;
    my $titreetiquete="";
    while (my $l=<OUT>) {
	$titreetiquete.=$l;
    }
    close(OUT);
    #----- le resume
    open (TMPFILE,">:encoding(utf-8)", $tmptag);
    print TMPFILE $texte,"\n";
    close(TMPFILE);
    system("perl cmd/tokenise-fr.pl $tmptag | tree-tagger langues-treetagger/french-utf8.par -lemma -token -no-unknown -sgml > treetagger.txt");
    system("perl cmd/treetagger2xml-nadia.pl treetagger.txt");
    # lecture du resultat tagge en xml :
    open(OUT,"<:encoding(utf-8)","treetagger.txt.xml");
    my $fistline=<OUT>;
    my $texteetiquete="";
    while (my $l=<OUT>) {
	$texteetiquete.=$l;
    }
    close(OUT);
    # on renvoie les resultats :
    return ($titreetiquete,$texteetiquete);
}
#------------------------------------------------------
